function gtDoAll;
% remove seg2vie.sh
% truncate grainid
% set GrainID in extspot to null
% remove -r 4_grain/*

%load data
parameters=[];
if isempty(parameters)
  load('parameters.mat');
end

cd(parameters.acq.dir);

cand=gtSelectCandidates(220,450);

fprintf('Candidate list length: %d\n',length(cand));


%cand(cand==4)=[];%kill dodgy entry number 4!

for i=1:length(cand)
  
  close all
  if mym(sprintf('select !isnull(GrainID) from %sextspot where (extspotID=%d)',parameters.acq.name,cand(i)));
    % GrainID has already been allocated to this candidate
    continue % bomb out of loop
  end
  

  % request a GrainID to use
  mym(sprintf('insert into %sgrainid set grainID=default',parameters.acq.name));
  grainID=mym(sprintf('select last_insert_id()'));
  fprintf('now looking at candidate %d of %d (family belonging to extspot(%d)) using grainID %d\n',i,length(cand),cand(i),grainID);
  %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  [accept, stack] = gtHandleSpot(cand(i),grainID);
  %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

  if accept

    %consistancy check writes data into the grain%d_.mat file
    %returns a list of rejected struct_ids, the extspot.GrainID entries
    %for which must be reset
    %use overwite flag=1 to remove bad data from the grain%d_.mat file
    %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    [struct_ids,a,a,a,a,bad_struct_ids]=gtConsistancyCheck(grainID,1);
    %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    %do the database reset here
    if ~isempty(bad_struct_ids);
      disp('Resetting bad grainIDs')
      fprintf('removing bads: ')
      fprintf('%d ',bad_struct_ids)
      fprintf('\n')
      gtResetGrainID(bad_struct_ids);
    end
    
    if length(struct_ids)>=4
    %write stack and information about scan
    disp(sprintf('writing %d projections for grain %d',length(struct_ids),grainID));
    %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    gtWriteStack(grainID);
    %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    %do ART after consistancy check, not before!
    %[lamba, use_grain] = gtnew_choose_art_params_wolf(grainid);
    %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    gtDoART(grainID);
    %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    else
      disp('removing this grain, not enough projections');
      %reset and remove grain...
      gtResetGrainID(struct_ids);
      cmd = sprintf('rm -rf 4_grains/grain%d_',grainID);
      unix(cmd)
    end

    
    cd(parameters.acq.dir);
  end
end

disp('Done!')
