function [spot, bb] = gtGetSummedDifSpot(difID, parameters, connected, info)
% returns the summed difspot image (saved as difspot%05d.edf) or in difblobtable
% 360degree scan convention - ak 10/2007
% speed up by providing edfheader info
    if ~exist('parameters','var')
        disp('loading parameters...');
        load('parameters.mat');
    end  

    % connect to database
    if (~exist('connected', 'var'))
        connected = false;
    end
    if ~connected
        gtDBConnect()
    end

    if (~exist('info', 'var'))
        info = [];
    end
    
    name = parameters.acq.name;
    query = sprintf('select BoundingBoxXOrigin, BoundingBoxYOrigin, BoundingBoxXSize, BoundingBoxYSize from %sdifspot where difspotID=%d',name,difID);
    bb=[];
    
    filename2 = fullfile(parameters.acq.dir, '2_difspot', sprintf('difspot%05d.edf', difID) );
    if exist(filename2, 'file') %read the edf file
        spot=edf_read(filename2,[],[],info);
        if nargout==2
          [bb(1),bb(2),bb(3),bb(4)]=mym(query);
        end  
    
     else 	
        try
            %tablename=sprintf('%sdifblobdetails',name);
            tablename = name;
            [vol,bb] = gtDBBrowseDiffractionVolume(tablename, difID);
            spot = sum(vol,3);
        catch Mexc
            gtPrintException(Mexc, 'cannot find difspot as edf or as difblob!')
        end
     end
end
