function accept=gtHandleSpot_360(spot_id,grainid, pars)

%subtle renaming - gtHandleSpot_360 is gtHandleSpot2_360, reworked to deal
%with a single 360 scan


%modify to the new 360 data structure - two extspot tables and a pair table
%containing all/any pair derived information.
%gtDoAll2_360 should ensure that the working directory is the first half of
%the scan.

%add filter to use condition of known valid Theta angles to help...

%sufficient to return "accept" only, all data written to grain%d_.mat

%simplify further - crazy to make sinogram for every extspot considered.
%Instead, just use the centroid information contained in the database for
%the first attempt
%modify to also calculate the plane normals, hkls, so these can be passed
%to a consistancy test

%360degree scan convention - ak 10/2007

parameters=[];
if ~exist('pars','var')
    pars=load('parameters.mat');
    parameters=pars.parameters;
else
    parameters=pars;
end
plot_flag=0; %set to one to see figures!
debug_flag=0;% switch one keyboard statements
replace_flag=0; %set to one to replace all extspot with difspots when making grains/sinos/stacks

grainpos=[0 0 0];
accept = 0;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%      get parameters of the seed spot              %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
mysqlcmd=sprintf([...
    'select Yorigin,Yorigin+Ysize, Ycentroid from '...
    '%sbboxes inner join %sbb on %sbboxes.bboxID=%sbb.bbID '...
    'where %sbb.extspotID="%d"'],...
    parameters.acq.name,...
    parameters.acq.name,...
    parameters.acq.name,...
    parameters.acq.name,...
    parameters.acq.name,...
    spot_id);
[minY,maxY,spot_centroidy]=mym(mysqlcmd);

AllowedError = max(5,ceil((maxY-minY)/parameters.match.heighttol));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  find related spots - single 360 scan
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
mysqlcmd=sprintf([...
    'select %sbb.extspotID, Xcentroid, Ycentroid '...
    'from %sbboxes inner join %sbb on %sbboxes.bboxID=%sbb.bbID where '...
    ' (abs(Yorigin - %d)<%f) AND (abs(Yorigin+Ysize-%d)<%f) AND isnull(GrainID) '...
    ' order by %sbb.extspotID'], ...
    parameters.acq.name,...
    parameters.acq.name,...
    parameters.acq.name,...
    parameters.acq.name,...
    parameters.acq.name,.....
    minY,AllowedError,...
    maxY,AllowedError,...
    parameters.acq.name);
[struct_ids,centroidx,centroidy] =mym(mysqlcmd);

if debug_flag
    keyboard
end

%which of struct_id vector is the original spot (spot_id)
index = find(struct_ids==spot_id);
%get omega angles
omega = gtGetOmega(struct_ids, parameters);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% get allowed TwoTheta data for filter
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

twotheta=parameters.cryst.twoth;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%make original spot centre line - don't use sino, use centroid only
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[orig_grad, orig_intersect] = sfMakeBackProLine2(spot_id, struct_ids, centroidx, omega, parameters);

%plot original centre line  % cannot represent vertical line with y=mx+b
if plot_flag
    figure;
    ez_orig=ezplot(sprintf('%f*x + %f',orig_grad,orig_intersect),[1 parameters.acq.bb(3)]);
    set(ez_orig,'color','g');
    axis ij
    axis equal
    axis([1 parameters.acq.bb(3) 1 parameters.acq.bb(3)])
    hold on
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%loop through all spots using theta filter
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
good_points=[];counter=1;
disp('Examining spots...')
warning('assuming centre of rotation to be at centre of acq.bb - in sfMakeBackProLine')
save_theta=[];

for i=1:length(struct_ids)

    if i == index % don't need to do original spot
        continue
    end

    %make spot centre line
    [grad, intersect] = sfMakeBackProLine2(struct_ids(i), struct_ids, centroidx, omega, parameters);

    %calculate intersection with original spot line
    tmpx = -(intersect-orig_intersect)/(grad-orig_grad);
    tmpy = (orig_grad*tmpx) + orig_intersect;

    % only continue if intersection is inside image
    %  if tmpy<parameters.acq.bb(4) && tmpy>1 && tmpx<parameters.acq.bb(3) && tmpx>1
    %circular sample case:
    %  if ((tmpx-(parameters.acq.bb(3)/2))^2+(tmpx-(parameters.acq.bb(3)/2))^2)<(parameters.acq.bb(3)/2)^2
    %circular sample case, plus a 30% margin of error:
    if ((tmpx-(parameters.acq.bb(3)/2))^2+(tmpx-(parameters.acq.bb(3)/2))^2)<(1.3*parameters.acq.bb(3)/2)^2

        if plot_flag
            axis([1 parameters.acq.bb(3) 1 parameters.acq.bb(3)])
            plot(tmpx, tmpy, 'xr')
        end

        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        %Theta filter  orig and current spots
        %using grainpos = tmpx, tmpy, calc theta
        %use the vertical position of the seed spot centroid
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        [Theta_spot, Eta_spot] = gtFindAngles_360(struct_ids(i), tmpx, tmpy, centroidy(index),  (180/pi)*omega(i), parameters);
        [Theta_orig, Eta_orig] = gtFindAngles_360(struct_ids(index), tmpx, tmpy, centroidy(index),  (180/pi)*omega(index), parameters);

        save_theta=[save_theta Theta_spot Theta_orig];
        %to use a percentage angle criteria
        %    min_spot_dif = min(abs((twotheta/2)-Theta_spot)./(twotheta/2));
        %    min_orig_dif = min(abs((twotheta/2)-Theta_orig)./(twotheta/2));

        %to use an absolute allowed margin of error (as in consistancy check)
        min_spot_dif = min(abs((twotheta/2)-Theta_spot));
        min_orig_dif = min(abs((twotheta/2)-Theta_orig));

        %    if (min_spot_dif<0.025 && min_orig_dif<0.025)% if both Thetas good to 2.5%
        if (min_spot_dif<parameters.sort.theta_filter && min_orig_dif<parameters.sort.theta_filter)%use value from parameters.sort

            %plot good point
            if plot_flag
                plot(tmpx, tmpy, 'go')
            end
            %record point in good points
            %good points(1)=x, (2)=y, (3)=struct_id, (4)=dist (later), (5)=ycentroid
            good_points(counter,1)=tmpx;
            good_points(counter,2)=tmpy;
            good_points(counter,3)=struct_ids(i);
            good_points(counter,5)=centroidy(i);
            counter=counter+1;

        end
    else
        if debug_flag
            disp('intersection outside of circular sample')
        end
    end
end

if debug_flag
    keyboard
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%find grain position from good_points
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if size(good_points,1)>4 % need at least 5 spots to proceed...(1)

    x_grain = fminbnd(@(x_grain) sfFindGrain(good_points, x_grain), min(good_points(:,1)), max(good_points(:,1)));
    y_grain = (orig_grad*x_grain) + orig_intersect;
    if plot_flag
        plot(x_grain, y_grain, 'cx', 'markersize', 20) % plot the chosen center
    end
    %find width of original projection
    [a,orig_sino,a]=gtReadSpots_360(spot_id, spot_id, replace_flag, parameters);%produce sinogram for original spot only

    if (max(orig_sino)>0)  %if the max of the sinogram is zero, then the extspot must be bad(2)

        orig_binsino = orig_sino>0.1*max(orig_sino);
        dummy=find(orig_binsino==1);
        orig_min=min(dummy);
        orig_max=max(dummy);
        proj_radius = (orig_max - orig_min)/2;

        %calc distance of intersections from grain position
        good_points(:,4) = sqrt((good_points(:,1)-x_grain).^2+(good_points(:,2)-y_grain).^2);
        %remove intersections far from grain center
        dummy = find(good_points(:,4)>proj_radius);
        good_points(dummy, :)=[];

        %plot the final set of intersections
        if plot_flag
            plot(good_points(:,1), good_points(:,2), 'ko', 'markersize', 10)
        end

        %collect the good struct_ids, pair_vector, for this grain, and the z
        %position
        good_struct_ids = [spot_id good_points(:,3)'];
        z_pos = mean([spot_centroidy good_points(:,5)']);

        struct_ids = good_struct_ids;

        Omega =  (180/pi)*gtGetOmega(struct_ids, parameters);%put into degrees

        %need at least five projections of grain for a useful reconstruction.
        if length(struct_ids) > 4  %(3)

            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %%
            %%
            %call gtFindAngles with the initial guess at the grain centre
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

            [Theta, Eta] = gtFindAngles_360(struct_ids, x_grain, y_grain, z_pos, Omega, parameters);

            %calculate plane normal vectors for consistancy check
            [plane_normal,  hkl] = gtIndexReflections(Theta,Eta,Omega, parameters);
            %run consistancy check
            %modif sabine
            % [R_vector, good_plnorms] = plot_rodrigues_consistancy(plane_normal, hkl, 0);
            [R_vector, good_plnorms] = plot_rodrigues_consistancy_test(plane_normal, hkl, 0);
            % fin modif sabine
            %remove bad (inconsistant) data
            kill_list = find(~good_plnorms);

            %warning('consistancy check disabled!!!')
            %kill_list=[];

            if debug_flag
                keyboard
            end

            Theta(kill_list)=[];
            Eta(kill_list)=[];
            Omega(kill_list)=[];
            struct_ids(kill_list)=[];
            plane_normal(kill_list,:)=[];
            hkl(kill_list,:)=[];


            %need at least five projections of grain for a useful reconstruction.
            if length(struct_ids) > 4  % (4)

                %calculate a better centroid to use in forward simulation
                [stack,sino,z_of_sino]=gtReadSpots_360(spot_id, struct_ids, replace_flag, parameters);
                try
                    s=sfMakeGrain(sino, Omega, x_grain, y_grain, plot_flag);
                catch
                    disp('sfMakeGrain failed!')
                    return
                end


                if max(s.BoundingBox(3:4))>(4*proj_radius) %very large bbox sign of messed up grain reconstruction
                    grainCentroid=[x_grain y_grain z_pos];%x,y,z of grain
                else
                    grainCentroid=[s.Centroid z_pos];%x,y,z of grain
                end


                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                %forward simulation here - search database for more difspot-extspot pairs
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                add_struct_ids=gtForwardSimulate_360(grainCentroid,R_vector, struct_ids, parameters)
                struct_ids = [struct_ids add_struct_ids];

                Omega =  (180/pi)*gtGetOmega(struct_ids, parameters);%put into degrees

                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                %repeat previous steps with added struct_ids
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                [stack,sino,z_of_sino]=gtReadSpots_360(spot_id, struct_ids, replace_flag, parameters);
                try
                    s=sfMakeGrain(sino, Omega, x_grain, y_grain, plot_flag);
                catch
                    disp('sfMakeGrain failed!')
                    return
                end


                if max(s.BoundingBox(3:4))>(4*proj_radius) %very large bbox sign of messed up grain reconstruction
                    grainCentroid=[x_grain y_grain z_pos];%x,y,z of grain
                else
                    grainCentroid=[s.Centroid z_pos];%x,y,z of grain
                end

                %final calculations of Theta, Eta, plane_normals using grain centroid
                [Theta, Eta] = gtFindAngles_360(struct_ids, s.Centroid(1), s.Centroid(2), z_pos, Omega, parameters);
                %calculate plane normal vectors for consistancy check
                [plane_normal,  hkl] = gtIndexReflections(Theta,Eta,Omega, parameters);

                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                %repeat consistancy check with added spot pairs
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                % modif sabine
                %[R_vector, good_plnorms] = plot_rodrigues_consistancy(plane_normal, hkl, 0);
                [R_vector, good_plnorms] = plot_rodrigues_consistancy_test(plane_normal, hkl, 0);
                % fin modif sabine
                %remove bad (inconsistant) data - shouldn't be any at this point!
                kill_list = find(~good_plnorms);
                %   warning('consistancy check disabled!!!')
                %  kill_list=[];
                if debug_flag
                    keyboard
                end
                Theta(kill_list)=[];
                Eta(kill_list)=[];
                Omega(kill_list)=[];
                struct_ids(kill_list)=[];
                plane_normal(kill_list,:)=[];
                hkl(kill_list,:)=[];
                stack(:,:,kill_list)=[];
                sino(:,kill_list)=[];


                %need at least five projections of grain for a useful reconstruction.
                if length(struct_ids) > 4  %(5)
                    accept =1;

                    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                    %collect data for .mat file, pad bounding boxes...
                    %get z position data from database
                    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

                    for i=1:length(struct_ids)
                        query=sprintf(['select Yorigin,Yorigin+Ysize from '...
                            '%sbb inner join %sbboxes on bbID=bboxID '...
                            'where %sbb.extspotID=%d'],...
                            parameters.acq.name, parameters.acq.name, parameters.acq.name,...
                            struct_ids(i));
                        [zstart(i),zend(i)]=mym(query);
                    end

                    %bounding box data
                    zstart=min(zstart);
                    zend=max(zend);
                    x1 = ceil(s.BoundingBox(1)); %gt bbox ceil
                    y1 = ceil(s.BoundingBox(2)); %gt bbox ceil
                    xend = x1 + s.BoundingBox(3);
                    yend = y1 + s.BoundingBox(4);
                    %centres
                    xcenter=round(s.Centroid(1));
                    ycenter=round(s.Centroid(2));
                    zcenter=round(z_pos);

                    %add 20% to bounding box for luck (x-y plane only for extspot recon)
                    x1 = round(x1 - (s.BoundingBox(3)/5));
                    if x1 < 1
                        x1 = 1;
                    end
                    y1 = round(y1 - (s.BoundingBox(4)/5));
                    if y1 <1
                        y1 = 1;
                    end
                    xend = round(xend + (s.BoundingBox(3)/5));
                    if xend > parameters.acq.bb(3)
                        xend = parameters.acq.bb(3);
                    end
                    yend = round(yend + (s.BoundingBox(4)/5));
                    if yend > parameters.acq.bb(3)
                        yend = parameters.acq.bb(3);
                    end

                    nx = xend-x1;
                    ny = yend-y1;
                    nz = zend-zstart;

                    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                    %save grainid into database structure
                    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

                    if 1%do save

                        for i=1:length(struct_ids)

                            %update grainID in extspot table
                            mysqlcmd=dbUpdate(sprintf('%sextspot',parameters.acq.name),'extspotID',struct_ids(i),'GrainID',grainid);
                            mym(mysqlcmd);
                            %update grainID in bb table (!)
                            mysqlcmd=dbUpdate(sprintf('%sbb',parameters.acq.name),'extspotID',struct_ids(i),'grainID',grainid);
                            mym(mysqlcmd);

                        end

                        %save mat file
                        grainname=sprintf('grain%d_',grainid);
                        graindir=sprintf('%s/4_grains/%s',parameters.acq.dir,grainname);
                        if ~exist(graindir,'dir')
                            mkdir(graindir);
                        end
                        name=sprintf('%s/%s.mat',graindir,grainname);
                        save(name,'struct_ids','stack','zstart','zend','zcenter','x1','nx','y1','ny','xcenter','ycenter','Omega','Theta', 'Eta','plane_normal','hkl','R_vector');
                    else
                        disp('debug/test mode!')

                    end


                else
                    disp(sprintf('only %d projections related to spot %d after foward simulation+consistancy check2 - skipping',length(struct_ids),spot_id))
                end  %(5)

            else
                disp(sprintf('only %d projections related to spot %d after consistancy check - skipping',length(struct_ids),spot_id))
            end   % (4)

        else
            disp(sprintf('only %d good points on projection of spot %d with similar positions- skipping',size(good_points,1),spot_id))
        end    %(3)

    else
        disp('Bad original sinogram for this spot (negative extspot intensity!)')
        if debug_flag
            keyboard
        end
    end   %(2)

else
    disp(sprintf('only %d good points on projection of spot %d - skipping',size(good_points,1),spot_id))
end   % (1)





end  %end of the function







function [m, c] = sfMakeBackProLine(spot_id, struct_ids, sino, theta)
%function to return the parameters of a line passing through the proj of a
%given spot, struct_ids is vector of spots in the sinogram, sino.
index = find(struct_ids == spot_id);

%get spot parameters
spot_sino=sino(:,index);
spot_com=(spot_sino'*[1:length(spot_sino)]')/sum(spot_sino);
spot_omega=theta(index);

%experiment parameters
centre_of_backproimg_x = size(sino,1)/2;
centre_of_backproimg_y = size(sino,1)/2;

point=[centre_of_backproimg_x, centre_of_backproimg_y];

%make line parameters
grad=1/tan(spot_omega);

%dist of com line from centre
offset_com=spot_com-length(spot_sino)/2;
%centre point of line though the projection
point=point+(offset_com*[cos(spot_omega) -sin(spot_omega)]);

%put into format y = mx + c
m = grad;
c = point(2) - (m*point(1));
end

function [m, c] = sfMakeBackProLine2(spot_id, struct_ids, centroidx, omega, parameters)
%function to return the parameters of a line passing through the centroid of a
%given spot, struct_ids is vector of spots in the sinogram.

index = find(struct_ids==spot_id);

%get spot parameters
spot_com=centroidx(index);
spot_omega=omega(index);
%experiment parameters
centre_of_backproimg_x = parameters.acq.bb(3)/2;
centre_of_backproimg_y = parameters.acq.bb(3)/2;
point=[centre_of_backproimg_x, centre_of_backproimg_y];
%make line parameters
grad=1/tan(spot_omega);
%dist of com line from centre
offset_com=spot_com-parameters.acq.bb(3)/2;
%centre point of line though the projection
point=point+(offset_com*[cos(spot_omega) -sin(spot_omega)]);
%put into format y = mx + c
m = grad;
c = point(2) - (m*point(1));
end


%function [Theta,Eta] = sfFindAngles(struct_id, pair, grainx, grainy, grainz, omega);
%omega=omega*180/pi; %gtFindAngles works in radians...
%[Theta,Eta] = gtFindAngles_pair(struct_id, pair, grainx, grainy, grainz, omega);
%end


function output = sfFindGrain(good_points, x_grain)
%function for fminbnd to find grain position along original projection
dif = good_points(:,1)-x_grain;
%minimise sum of squares for the closest half of the points, to reduce
%effect of outliers
dif = abs(dif);
dif = sort(dif,1,'descend');
tmp = ceil(size(dif,1)/2);
dif(1:tmp)=[];
output = dif'*dif;%sum of squares
end

function s = sfMakeGrain(sino, Omega, x_grain, y_grain, plot_flag)

%back project good spots only
binsino = sino>0.1*max(sino(:));
img2=backpro(binsino,(pi/180)*Omega);

%do imreconstruct from centre to threshold grain
x_grain = ceil(x_grain); y_grain = ceil(y_grain);
marker=zeros(size(img2));
marker(y_grain, x_grain)=1;
mask=double((img2>0.8*img2(y_grain, x_grain)));

try
    grain=imreconstruct(marker,mask);
    if plot_flag
        figure
        h1=imshow(cat(3,img2,zeros(size(img2)),zeros(size(img2))),[]);
        hold on
        h2=imshow(cat(3,zeros(size(img2)),grain,zeros(size(img2))),[]);
        set(h2,'alphadata',0.5);
    end
    s=regionprops(grain,'Area','BoundingBox','Centroid');

catch
    disp('Marker/mask problem - bombed out')
    accept=false;
    return
end


end
