%
% Normalize the direction vectors of 3D lines given in matrix form.
%
% INPUT:  l(n,6) [ point_X point_Y point_Z norm_dir_X norm_dir_Y norm_dir_Z] =
%           any number of 3D lines in matrix form
%             
% OUTPUT: l(n,6) [ point_X point_Y point_Z norm_dir_X norm_dir_Y norm_dir_Z] =
%           3D lines in matrix form with direction vectors normalized
%



function norm_l=normlinedir(l)

n=sqrt(sum(l(:,4:6).*l(:,4:6),2));

norm_l=[l(:,1:3) l(:,4)./n l(:,5)./n l(:,6)./n];
