function [slice,sino]=gtAbsorptionSlice(parameters,slicenumber,varargin)
% function [slice,sino]=gtAbsorptionSlice(parameters,slicenumber,varargin)
% reconstructs a single absorption slice using matlabs irandon function
% slicenumber:   number of the slice to be reconstructed
%
% optional input argument: interval
%
% int = 10  uses only one out of 10 projections  (speed up...)

if nargin>2
  int=varargin{1};
else
  int=1;
end


acq=parameters.acq;


step=180/acq.nproj*int;

theta=[0:step:180-step];

sino=zeros(acq.bb(3),length(theta));


j=1;
disp('assembling sinogram..');
if parameters.acq.interlaced=1;
  absname='abs_renumbered';
else
  absname='abs';
end

for i=0:int:acq.nproj-1
  sino(:,j)=edf_read(sprintf('%s/1_preprocessing/abs/%s%04d.edf',acq.dir,absname,i),[1,slicenumber,acq.bb(3),1]);
  j=j+1;
end

disp('backprojecting...')
sino=-log(sino);
slice=iradon(sino,theta,'linear','Ram-Lak',1,acq.bb(3));
imshow(slice,[])