function [vol,bbox]=gtMakeARTJob3D_no_ssh(scanname,parfilename,dif_numbers,ext_numbers,grain,parameters,lambda,bs,x1,nx,y1,ny,z1,nz,do_reconstruction,show_result)
% write .par file ready for rec_alg to use
%
%
% function
% make_art_parfile(scanname,parfilename,dif_numbers,shear_numbers,ext_numbe
% rs, grain, lambda,parameters,slice)
% scanname  : name of scan
% parfilenane: name of parameterfile (output)
% dif_numbers: indices of diffraction spots to be taken into account, e.g. [1:14]
% shear_numbers: indices of sheared diffraction spots to be taken into account 
% ext_numbers:   : indices of extinction spots to be taken into account
% grain:
% lambda: 
% parameters:
% 


%load('parameters.mat');
gtMakeLinks3D(scanname,dif_numbers,ext_numbers);

blocksize= bs;%length(dif_numbers)+length(ext_numbers);


offset=0;

fid=fopen(parfilename,'w');
nbradio=length(dif_numbers)+length(ext_numbers);

% Algorithm paramters
nbiter = length(lambda);
nbiter_half_quadra = 1;
nbsauv = nbiter;
rec_gene_filename = scanname;
ext_rec0 = 1;
if nbiter>1
   lambda_flag = 1;
else
   lambda_flag=0;
end   	

err_flag = 0;
algo_type = 2;    %ART
block_size = blocksize;
proj_mng = 'A';   
nb_resol = 1;

thresh_supp = 0;
clip_supp = 4;
clip_sphere = 0;
histo_size = 100;
maxvol = 1000.;
minvol = -10.;
vol_type = 3;

% not used
param1 = 0.1;
param2 = 0.00005;
param3 = 0.00005;
param4 = 0.05;
param5 = 0.82;

% fixed Geometry parameters
% we set pixelsize = 1mm
% geometry paramters: origin of detector [PGd QGd] = 0 0 for all images
fgd  = 10000000;     % Distance source to detector ~ 10^7 times pixelsize
pgd  = 0;            % horizontal Distance (source projection)-(detector center) [pixels]
qgd  = 0;            % vertical Distance (source projection)-(detector center) [pixels]
pepd = 1;            % horizontal Pixel size, [mm]
peqd =-1;            % vertical Pixel size [mm]:  has to be negative for scanning direction from top to bottom
m0   = fgd-parameters.acq.dist/parameters.acq.pixelsize;             % distance source - rotation axis [mm] (positive here: -m0 will be given to AREMIS 

%Reconstruction paramters
pex = 1;             % sampling step size [mm]
pey = 1;             % sampling step size [mm]
pez = 1;             % sampling step size [mm] 



% write diffraction spot section (3D-ART) 

for i=1:length(dif_numbers)

  Omega =   grain.omega(dif_numbers(i));
  Theta =   grain.theta(dif_numbers(i));
  Eta   =   -grain.eta(dif_numbers(i));    
  psi(i)=   Omega;               % first Euler angle (==omega)  [degrees]
  xsi(i)=   90.0;                % second Euler angle
  delta =   0.0;                 % third Euler angle

  
  query=sprintf('select BoundingBoxXorigin,BoundingBoxYorigin,BoundingBoxXsize,BoundingBoxYsize from %sdifspot where DifspotID=%d',parameters.acq.name,grain.difspots(dif_numbers(i)));
  [bb(1),bb(2),bb(3),bb(4)]=mym(query);
  %now take into account the flip of the images...
  bb(1)=2*parameters.acq.rotx-bb(1)-bb(3)+1;
  bb=bb+[-100 -100 200 200];
  bbox(i,:)=bb; 
  
  %bb=parameters.bb(dif_numbers(i),1:4) +[-100 -100 200 200];  %gtForward_Project
  
  p1d(i) =      m0*tand(2*Theta)*sind(Eta)+bb(1)-parameters.acq.rotx;      % orig left  detector corner [pixels]
  
  q1d(i) =      m0*tand(2*Theta)*cosd(Eta)+parameters.acq.ydet/2-bb(2);    % orig upper detector corner [pixels]     
 
  np(i)=bb(3);                % horizontal detector size [pixels]  
  nq(i)=bb(4);                % vertical detector size [pixels]

  p0(i) =    m0*tand(2*Theta)*sind(Eta);             % horizontal  distance source - object center [mm]
  q0(i) =    m0*tand(2*Theta)*cosd(Eta);             % vertical distance source - object center [mm]

  ipd = 0;               % ROI begin horizontal [pixels] 
  iqd = 0;               % ROI begin vertical [pixels]
  ipf(i) = np(i)-1;      % ROI end horizontal [pixels]
  iqf(i) = nq(i)-1;      % ROI end vertical

end

% now write extinction spots...

off2=length(dif_numbers);
nof_spots=length(grain.difspots);

for i=1:length(ext_numbers)
 
  Omega =   grain.omega(ext_numbers(i));  %should be changed in order to include extspots from additional reflections, other than the difspots...
  Theta =   0;
  Eta   =   0;    

  psi(i+off2) = Omega;           % first Euler angle (==omega)  [degrees]
  xsi(i+off2) = 90.0;            % second Euler angle
  delta =  0.0;                  % third Euler angle

  bb=parameters.acq.bb;

  p1d(i+off2) =     bb(1)-parameters.acq.rotx;      % left  detector corner [pixels]
  q1d(i+off2) =     parameters.acq.ydet/2-bb(2);    % upper detector corner [pixels]     
  np(i+off2)=bb(3);                % horizontal detector size [pixels]  
  nq(i+off2)=bb(4);                % vertical detector size [pixels]

  p0(i+off2) =    0;               % horizontal  distance source - object center [mm]
  q0(i+off2) =    0;               % vertical distance source - object center [mm]

  ipd = 0;                         % ROI begin horizontal [pixels] 
  iqd = 0;                         % ROI begin vertical [pixels]
  ipf(i+off2) = np(i+off2)-1;      % ROI end horizontal [pixels]
  iqf(i+off2) = nq(i+off2)-1;      % ROI end vertical

end

% write out parameter file for AREMIS

fprintf(fid,'PAGBEGIN SYSTEMAL\n');
fprintf(fid,'PROJ_GENE_FILENAME = proj\n');  %%s\n',scanname);

for i=1:length(dif_numbers)
  fprintf(fid,'EXT_PROJ%d = %d\n',i-1,dif_numbers(i));  %dif_numbers(i))
end
% for i=1:length(shear_numbers)
%   fprintf(fid,'EXT_PROJ%d = %d\n',i+off-1,i+off);
% end
for i=1:length(ext_numbers)
  fprintf(fid,'EXT_PROJ%d = %d\n',i+off2-1,ext_numbers(i)+off2);   %ext_numbers(i)+off2);
end  

fprintf(fid,'NBITER = %d\n',nbiter);
fprintf(fid,'NBITER_HALF_QUADRA = %d\n',nbiter_half_quadra);
fprintf(fid,'NBSAUV = %d\n',nbsauv);
fprintf(fid,'REC_GENE_FILENAME = %s\n',rec_gene_filename);
for i=1:nbiter
     fprintf(fid,'EXT_REC%d = %d\n',i-1,i);
end 
    
fprintf(fid,'LAMBDA_FLAG = %d\n',lambda_flag);
if lambda_flag
  for i=1:nbiter
     fprintf(fid,'LAMBDA%d = %f\n',i-1,lambda(i));
   end
else 
  fprintf(fid,'LAMBDA = %f\n',lambda);
end       
fprintf(fid,'ERR_FLAG = %d\n',err_flag);
fprintf(fid,'ALGO_TYPE = %d\n',algo_type);
fprintf(fid,'BLOCK_SIZE = %d\n',block_size);
fprintf(fid,'PROJ_MNG = %s\n',proj_mng);
fprintf(fid,'NB_RESOL = %d\n',nb_resol);
fprintf(fid,'THRESH_SUPP = %d\n',thresh_supp);
fprintf(fid,'CLIP_SUPP = %d\n',clip_supp);
fprintf(fid,'CLIP_SPHERE = %d\n',clip_sphere);
fprintf(fid,'HISTO_SIZE = %d\n',histo_size);
fprintf(fid,'MAXVOL = %f\n',maxvol);
fprintf(fid,'MINVOL = %f\n',minvol);
fprintf(fid,'VOL_TYPE = %d\n',vol_type);
fprintf(fid,'PARAM1 = %f\n',param1);
fprintf(fid,'PARAM2 = %f\n',param2);
fprintf(fid,'PARAM3 = %f\n',param3);
fprintf(fid,'PARAM4 = %f\n',param4);
fprintf(fid,'PARAM5 = %f\n',param5);

fprintf(fid,'PAGEND SYSTEMAL\n') ;
fprintf(fid,'PAGBEGIN ACQGEO\n');
fprintf(fid,'NBRADIO = %d\n',nbradio);

for i=1:nbradio
fprintf(fid,'#radio %d origine position\n',i);
fprintf(fid,'POSITION = %d\n',i);
fprintf(fid,'FGD = %f\n',fgd);
fprintf(fid,'PGD = %f\n',pgd);
fprintf(fid,'QGD = %f\n',qgd);	
fprintf(fid,'PEPD = %f\n',pepd);	
fprintf(fid,'PEQD = %f\n',peqd);	
fprintf(fid,'P1D = %f\n',p1d(i));
fprintf(fid,'Q1D = %f\n',q1d(i));
fprintf(fid,'NP =  %d\n',np(i));
fprintf(fid,'NQ =  %d\n',nq(i));
fprintf(fid,'PSI = %f\n',psi(i));
fprintf(fid,'XSI = %f\n',xsi(i));
fprintf(fid,'DELTA = %f\n',delta);
fprintf(fid,'PO = %f\n',p0(i));	
fprintf(fid,'QO = %f\n',q0(i));
fprintf(fid,'MO = %f\n',-m0);
fprintf(fid,'IPD = %d\n',ipd);
fprintf(fid,'IQD = %d\n',iqd);
fprintf(fid,'IPF = %d\n',ipf(i));
fprintf(fid,'IQF = %d\n',iqf(i));
end

fprintf(fid,'PAGEND ACQGEO\n');
fprintf(fid,'PAGBEGIN OBJET\n');
fprintf(fid,'PEX = %f\n',pex);
fprintf(fid,'PEY = %f\n',pey);
fprintf(fid,'PEZ = %f\n',pez);
fprintf(fid,'X1 = %f\n',x1);
fprintf(fid,'Y1 = %f\n',y1);
fprintf(fid,'Z1 = %f\n',z1);
fprintf(fid,'NX = %d\n',nx);
fprintf(fid,'NY = %d\n',ny);
fprintf(fid,'NZ = %d\n',nz);
fprintf(fid,'PAGEND OBJET\n');

       
fclose(fid);
rec_alg='/users/bleuet/postdoc/programmes/main/new_ART/AREMIS/v2.0/bin/rec_alg';
seg2view='/users/bleuet/postdoc/programmes/main/new_ART/AREMIS/v2.0/bin/seg2view';

% now do the reconstruction
if do_reconstruction
    % without the ssh coral
  command=sprintf('cd %s;chmod 664 *res* fichier; %s %s;%s %s_res0_%d;chmod 664 *res* fichier',pwd,rec_alg,parfilename,seg2view,scanname,nbiter);
 unix(command);
 volname=sprintf('%s_res0_%d',scanname,nbiter)
 
 try % try so it doesn't die
    vol=sdt_read(volname);
	vol=flipdim(vol,2);
	%vol=flipdim(vol,1);
	%vol=flipdim(vol,3);% after these two operations the display is consistent with:  X (beam enters image at the bottom), Y positive to the left, Z positive at beginning of stack
 catch
     vol=[];
     disp('try failed - probably the file doesnt exist, but dont know why...')
 end
 
else
  vol=[];
end

if show_result
  figure(1);
  imshow(vol(:,:,round(nz/2)),[])
  drawnow;
end  
