            
function [vol, thresh_val]=gtThresholdGrain(vol);

%Theshold a grey scale volume, ie the output of the ART reconstruction
%improve the calculation of this value with respect to using graythresh

%explanation - we expect a histogram with a peak corresponding to the
%grain, and a peak a low values corresponding to the background of zeros.
%We want a threshold value below the peak corresponding to the grain, but
%above the background peak. Here we calculate one std dev below teh mean
%after excuding low values as a first estimate.  If there is a minimum in
%the histogram below this value, we will take it instead.

a=max(vol(:));
% one standard dev below the mean, excluding low (background) values 
val1=mean(vol(find(vol>(a/10))))-std(vol(find(vol>(a/10))));
% take histogram of the whole value
[n,x]=hist(vol(:),500);
% remove the part of the histogram above val1
n(find(x>val1))=[];
x(find(x>val1))=[];
% find the minimum in this region
val2=min(x(find(n==min(n))));

thresh_val=min(val1, val2);

vol=vol>thresh_val;