function c_map = gtRandCmap(maxval)
% GTRANDCMAP(maxnum) Creates a random colourmap of 'maxval' random colours
% Returns a [maxval+1 by 3] 2D matrix (first line is black)

    background = [0 0 0]; %black background
    %background = [1 1 1]; %white background
    maxval = max(maxval, 1);
    c_map = [background; rand(uint64(maxval), 3)]; % returns a [maxnum+1 by 3] 2D matrix

    %increase brightness of dim colours
    int = sum(c_map, 2);
    indx = find(int < 1);
    indx(find(indx == 1, 1)) = []; %don't scale the zeros!
    c_map(indx, :) = 2 * c_map(indx, :) ./ repmat(int(indx), 1, 3);
    c_map(c_map > 1) = 1;
end
