function rmap = gtRvectorCmap(phase_id)

% make a colormap from the r_vectors.  Requires tha tthe r_vectors.mat
% variable has been created - use gtReadGrains

if ~exist('phase_id', 'var') || isempty(phase_id)
    phase_id = 1;
end

if exist('r_vectors.mat', 'file')
    load r_vectors
else
    disp('Loading most recent indexing output: index.mat');
    indexFile = fullfile('4_grains', sprintf('phase_%02d', phase_id), ...
        'index.mat');
    try
    load(indexFile);
    r_vectors=gtIndexAllGrainValues(grain, 'R_vector', '', 1:3, '');
    r_vectors=[zeros(size(r_vectors, 1), 1) r_vectors];
    catch mexc
        gtPrintException('neither r_vectors.mat nor index.mat was found :-(');
        rmap=[]
        return
    end
end

% get the three components of the r-vector
rmap=r_vectors(:,2:4);
% scale to 0-1
rmap=rmap-min(rmap(:));
rmap=rmap/max(rmap(:));
% black background
rmap=[0 0 0; rmap];

