function Qdet = gtFedDetectorProjectionTensor(detdiru, detdirv, ...
                                           detscaleu, detscalev)
% 
% Qdet = gtFedDetectorProjectionTensor(detdiru, detdirv, detscaleu, detscalev)
%
% INPUT  
%    detdiru, detdirv    - detector u,v directions in LAB coordinates
%                          (3x1 unit vectors)
%    detscaleu,detscalev - detector u,v scaling
%                          (grain voxel / det. pixel size) or (lab units /
%                          det. pixel size) or other units
%                          
% OUTPUT
%    Qdet - projection matrix that transforms LAB into DETECTOR coordinates
%


Qdet = [(detdiru/sqrt(detdiru'*detdiru))'*detscaleu ; ...
     (detdirv/sqrt(detdirv'*detdirv))'*detscalev];

end % end of function