function [dfac, clab] = gtFedPredictDiffFac(Rottens, dlab, csam, ...
                                            detrefpos, detnorm)
% [dfac,clab] = gtFedPredictDiffFac(Rottens, dlab, csam, detrefpos, detnorm)
%
% Gives the diffraction vector multiplicator.
% Diffraction vector dlab doesn't have to be normalised.
% csam,detrefpos must be in identical units.
%


% position of centre after rotation (sample -> lab coord.)
clab = Rottens*csam; % column 3x1

% the scalar multiplicator of the diffraction vector
dfac = detnorm'*(detrefpos-clab)/(detnorm'*dlab);

% beam won't hit the detector if dfac is negative
if dfac <= 0
	dfac = [];
end

end % end of function

