classdef GtBenchmarks
    methods (Static)
        function printHeader(funcName, dataSize)
            fprintf('\n%- 40s (Data size: %f GB)\n', funcName, dataSize / 2^30);
        end

        function printResult(message, result, dataVols)
            fprintf([message '\t'], result);
            if (exist('dataVols', 'var'))
                fprintf('Throughput: %f GB/s\n', dataVols / 2^30 / result);
            end
        end

        function bytes = getSizeVariable(var)
            info = whos('var');
            bytes = info.bytes;
        end

        function verifyError(reference, computed)
            fprintf('Checking errors in computation:\n')
            if (iscell(reference))
                fprintf('\t%g\n', max(cellfun(@(x, y)max(max(max(abs(x - y)))), reference, computed)));
            elseif (isscalar(reference))
                fprintf('\t%g (%g relative)\n', abs(reference - computed), abs((reference - computed)/reference) );
            else
                fprintf('\t%g\n', max(max(max(abs(reference - computed)))) );
            end
        end
    end
end
