function average = gtImgMeanValue2(content)
%GTIMGMEANVALUE2 Average or mean of matrix elements.
%   B = GTIMGMEANVALUE2(A) computes the mean of the values in A.
%
%   A needs to be a two dimensional matrix
%
%   Example
%   -------
%       img = edf_read('blabla.edf');
%       average = gtImgMeanValue2(img)
%  
%   See also MEAN, MEAN2, STD, STD2.

    if (exist('gtImgMeanValue', 'file') == 3)
        average = gtImgMeanValue(content);
    else
        average = sum(sum(content)) / numel(content);
    end
end

