%
% FUNCTION  angle = gtMathsVectorsAngles(v1,v2s)
%
% Gives the angles between a vector and a set of other vectors.
% Input vectors must be normalised.
%
% INPUT
%   v1          - an arbitrary 3D unit vector (1x3) 
%   v2s         - a set of arbitrary 3D unit vectors (nx3)
% 
% OUTPUT
%   angle       - list of angles between v1 and v2s (nx1)
%                 (in degrees, between 0deg and 90deg) 
%

function angle = gtMathsVectorsAngles(v1,v2s)

dotprod = abs(v2s*v1');

dotprod(dotprod>1) = 1;

angle = acosd(dotprod);
