function print_structure(structure, structurename, save, debug)
%     print_structure(structure,structurename, save, debug)
%     -----------------------------------------------------
%     Creates [structurename]_struct.txt with list of stuctures inside 'structure'
%     Creates [structurename].txt with output from the printing of
%     'structure'
%
%     INPUT:
%        structure     = structure to be printed <struct>
%        structurename = its name <string>
%        save          = 
%        debug         = 

if ~exist('structurename','var') || isempty(structurename)
    structurename='parameters';
end
if ~exist('save','var') || isempty(save)
    save = false;
end
if ~exist('debug','var') || isempty(debug)
    debug = true;
end

names=fieldnames(structure);

out = GtConditionalOutput(debug);

if save
    diary([structurename '.txt']);
    diary('on');
end

for i=1:length(names)
    isin=false;
    %out.odisp([structurename '.' names{i}])
    if isstruct(structure.(names{i})) 
        isin=true;
        subnames=fieldnames(structure.(names{i}));
        for j=1:length(subnames)
            isin=false;
            %out.odisp([names{i} '.' subnames{j}])
            if isstruct(structure.(names{i}).(subnames{j}))
                isin=true;
                subsubnames=fieldnames(structure.(names{i}).(subnames{j}));
                for k=1:length(subsubnames)
                    isin=false;
                    %out.odisp([names{i} '.' subnames{j} '.' subsubnames{k}])
                    if isstruct(structure.(names{i}).(subnames{j}).(subsubnames{k}))
                        isin=true;
                        subsubsubnames=fieldnames(structure.(names{i}).(subnames{j}).(subsubnames{k}));
                        for l=1:length(subsubsubnames)
                            isin=false;
                            %out.odisp([names{i} '.' subnames{j} '.' subsubnames{k} '.' subsubsubnames{l}])
                            if isstruct(structure.(names{i}).(subnames{j}).(subsubnames{k}).(subsubsubnames{l}))
                                isin=true;
                                subsubsubsubnames=fieldnames(structure.(names{i}).(subnames{j}).(subsubnames{k}).(subsubsubnames{l}));
                                for m=1:length(subsubsubsubnames)
                                    isin=false;
                                    %out.odisp([names{i} '.' subnames{j} '.' subsubnames{k} '.' subsubsubnames{l} '.' subsubsubsubnames{m}])
                                    if isstruct(structure.(names{i}).(subnames{j}).(subsubnames{k}).(subsubsubnames{l}).(subsubsubsubnames{m}))
                                        isin=true;
                                        out.odisp('Limit to down to the fifth level...')
                                    else
                                        isin=false;
                                    end
                                end % level 5
                                if ~isin
                                    out.odisp([structurename '.' names{i} '.' subnames{j} '.' subsubnames{k} '.' subsubsubnames{l}])
                                    out.odisp(structure.(names{i}).(subnames{j}).(subsubnames{k}).(subsubsubnames{l}))
                                end
                            else
                                isin=false;
                            end
                        end % level 4
                        if ~isin
                            out.odisp([structurename '.' names{i} '.' subnames{j} '.' subsubnames{k}])
                            out.odisp(structure.(names{i}).(subnames{j}).(subsubnames{k}))
                        end
                    else
                        isin=false;
                    end
                end % level 3
                if ~isin
                    out.odisp([structurename '.' names{i} '.' subnames{j}])
                    out.odisp(structure.(names{i}).(subnames{j}))
                end
            else
                isin=false;
            end
        end % level 2
        if ~isin
            out.odisp([structurename '.' names{i}])
            out.odisp(structure.(names{i}))
        end
        out.odisp(' ');
    end
end % level 1


if debug
    diary('off');
end

clear names subnames subsubnames subsubsubnames subsubsubsubnames
end % end print_function

